<?
/**************************************************************************************** 
 *											*
 *     Copyright (C) <2004>  <Josh J. Zelonis> <josh@dyadsecurity.com>			*
 *											*
 *											*
 *     This library is free software; you can redistribute it and/or			*
 *     modify it under the terms of the GNU Lesser General Public			*
 *     License as published by the Free Software Foundation; either			*
 *     version 2.1 of the License, or (at your option) any later version.		*
 * 											*
 *     This library is distributed in the hope that it will be useful,			*
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU		*
 *     Lesser General Public License for more details.					*
 * 											*
 *     You should have received a copy of the GNU Lesser General Public			*
 *     License along with this library; if not, write to the Free Software		*
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	*
 *											*
 ****************************************************************************************/

require("../config.php");


if ($_GET[_help] == "CIDR") {
print <<<EOF
<H3>CIDR:</H3>
To scan a single IP you would specify 192.168.1.1/32.  For a "class B" sized network, you would specify 172.16.0.0/16, etc.  See <a href="http://public.pacbell.net/dedicated/cidr.html" target="_new">this link</a> for more information on CIDR representation.
EOF;



} else if ($_GET[_help] == "scan_rate") {
print <<<EOF
<H3>Scan rate:</H3>
From a single Pentium system, it is typical to be able to generate up to 35,000 pps or more, but is highly dependant upon the quality of your hardware and your hardware drivers.  The pps limit should scale with your architecture accordingly.<br>
<br>
Proper logistics and controls preperation involves calculating the bandwidth and packets per second limits you have from the network you are testing from and the bandwidth and packets per second limits on the target network.  The <b>Scan rate</b> option specifies the rate at which we will send packets to the target.  A conservative number to start with is 150.  Other common speeds used are 250, 1000, 5000, 7500, and 10000.<br>
<br>
Warning, 10,000+ packets per second can crash many internetworking devices.  Be careful :).  This is especially true for local NAT devices.  We have seen SOHO boxes run out of state table in as little as 100+ pps.  Port scanning through NAT devices can really be painful.  To get the full power, scan from a machine with as few networking devices in its way as possible.<br>
EOF;



} else if ($_GET[_help] == "tcp_opts") {
print <<<EOF
<H3>TCP Options:</H3>
Unicornscan has the ability in the TCP options mode to specify what ever tcp header options you want.  For example checking "FIN" and "URG" would send tcp packets with FIN and URG bits inside the tcp header.<br>
<br>
Quick cheat list here:<br>
<b>SYN</b>: Check "SYN".<br>
<b>ACK</b>: Check "ACK".<br>
<b>FIN</b>: Check "FIN".<br>
<b>Null</b>: Check nothing.<br>
<b>Xmas</b>: "FIN","PSH","URG".<br>
<b>All</b>: Check everything.<br>
<br>
If you want to create your own special type of scan, just play with the options and document the results.<br>
<br>
See <a href="http://www.iana.org/assignments/tcp-header-flags" target="_new">this link</a> for more information of tcp header flags.<br>
EOF;



} else if ($_GET[_help] == "udp_opts") {
print <<<EOF
<H3>UDP:</H3>
Unicornscan supports the concept of actually speaking the protocol of the application you are trying to enumerate.<br>
<br>
For example, if you were scanning for DNS servers, one of the payloads tries to do a <i>localhost A record</i> request.  Another payload tries a <i>chaos.txt</i> request.  The last payload is a dynamic payload that will insert the IP address that you are scanning into the packet to do a reverse lookup of the target IP.<br>
<br>
In this way we are more acurately able to account for open UDP services.  We cover the most commonly used UDP based protocols and can add any additional protocol handshake as they are submitted to us.<br>
<br>
The payload trigger is not the only important piece for UDP scanning.  You also need to be mindful of which source port, dst port combinations are required for the protocol.  There are some payloads which must be generated "just in time" to be effective.<br>
<br>
Please email new handshakes to:<br>
unicornscan-handshakes at dyadsecurity.com.<br>
<br>
We prefere pcap formated dumps, such as results from:<br>
<i>tcpdump -n -s0 -w handshake.pcap</i>.<br>
EOF;



} else if ($_GET[_help] == "fantaip") {
print <<<EOF
<H3>FantaIP:</H3>
Because Unicornscan is forging packets for us independent of what the kernel is expecting to deal with, we have included a secondary program called fantaip.  Fantaip is a "Phantom IP" program that listens on a secondary IP address that we will use to receive response information to without confusing the kernel.  If you are going to check fantaip, you need to specify an otherwise unused IP address that routes back to your local network segment.<br>
<br>
If you specify an IP address that routes back to the physical segment that the specified (or default) interface card has visibility to, checking fantaip will allow Unicornscan to account for the response packets.<br>
<br>
If you are spoofing a sending IP address that does not route back to you, there is no need to check fantaip.<br>
EOF;



} else if ($_GET[_help] == "stack_emu") {
print <<<EOF
<H3>Stack Emulation:</H3>
Different kernels have different implementations of the TCP/IP stack.  These differences make up the "fingerprint" characteristics that tools like p0f, ids, firewalls, etc look at to determine the OS that created the packet.<br>
<br>
Because we are crafting the packets outside of the kernel, we can use what ever characteristics we want.  We included 3 in the pre-release for fun, Cisco router, OpenBSD, and Windows XP.<br>
<br>
The OpenBSD one is funny because some OpenBSD firewall admins will make special rules that only allow you to talk to them if you're coming from the right OS (OpenBSD in most cases).<br>
EOF;



} else if ($_GET[_help] == "repeats") {
print <<<EOF
<H3>Packet Repeat:</H3>
The -R option allows you to specify how many times to repeat sending a packet to the target range.  -R3 is a sane number to start with as it will provide for 3 sweeps into the target range.  Although the packets will go out 3 times, and you will likely get responses 3 times, the output will only show you the response once.  Again, you can check the pcap file you wrote to with the -w option to validate what is seen.  Also the -R option combined with the -r option can lead to DoS conditions. Also fun is specifying a source IP of r, for random.  This would make a Windows host based firewall have fun as the entire Internet is now attacking them :)  Be careful! :).<br>
EOF;



} else if ($_GET[_help] == "pcap_filter") {
print <<<EOF
<H3>PCAP Filter:</H3>
We noticed that sometimes in scanning you will see response data that you just don't care about.  We included this <b>PCAP Filter</b> option as a way to specify additional filters.<br>
<br>
For example if you wanted to exclude responses from the host 192.168.5.16, you would specify:<br>
<i>not host 192.168.5.16</i>.<br>
<br>
For more examples on how to use that feature, see <a href="http://www.tcpdump.org/tcpdump_man.html" target="_new">this link</a> starting with the line that says "selects which packets will be dumped".<br>
EOF;



} else {
print <<<EOF
Pound Sand.
EOF;
}

?>
