<?
/**************************************************************************************** 
 *											*
 *     Copyright (C) <2004>  <Josh J. Zelonis> <josh@dyadsecurity.com>			*
 *											*
 *											*
 *     This library is free software; you can redistribute it and/or			*
 *     modify it under the terms of the GNU Lesser General Public			*
 *     License as published by the Free Software Foundation; either			*
 *     version 2.1 of the License, or (at your option) any later version.		*
 * 											*
 *     This library is distributed in the hope that it will be useful,			*
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU		*
 *     Lesser General Public License for more details.					*
 * 											*
 *     You should have received a copy of the GNU Lesser General Public			*
 *     License along with this library; if not, write to the Free Software		*
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	*
 *											*
 ****************************************************************************************/


require("../config.php");
require($UNICORN["filesystem_unicorn-lib"]."responseclass.php");


function get_opts_mask($input,$mask)
{
	if (isset($input["mask"]))
		if (($input["mask"]&$mask) == $mask) $ret = "?mask=".($input["mask"]^1);
		else $ret = "?mask=".($mask|($input["mask"]&1));
	else $ret = "?mask=".$mask;
	$ret .= get_opts($input);
	return $ret;
}

function get_opts($input)
{	
	$ret = null;		
	$ret .= echo_on_set($input["host_addr"],null,"&host_addr=".$input["host_addr"]);
	$ret .= echo_on_set($input["trace_addr"],null,"&trace_addr=".$input["trace_addr"]);
	$ret .= echo_on_set($input["sport"],null,"&sport=".$input["sport"]);
	$ret .= echo_on_set($input["not_sport"],null,"&not_sport=".$input["not_sport"]);
	$ret .= echo_on_set($input["dport"],null,"&dport=".$input["dport"]);
	$ret .= echo_on_set($input["not_dport"],null,"&not_dport=".$input["not_dport"]);
	$ret .= echo_on_set($input["protocol"],null,"&protocol=".$input["protocol"]);
              	if ($input["protocol"] == "6") {
		$ret .= echo_on_set($input["TH_FIN"],null,"&TH_FIN=".$input["TH_FIN"]);
		$ret .= echo_on_set($input["TH_SYN"],null,"&TH_SYN=".$input["TH_SYN"]);
		$ret .= echo_on_set($input["TH_RST"],null,"&TH_RST=".$input["TH_RST"]);
		$ret .= echo_on_set($input["TH_PSH"],null,"&TH_PSH=".$input["TH_PSH"]);
		$ret .= echo_on_set($input["TH_ACK"],null,"&TH_ACK=".$input["TH_ACK"]);
		$ret .= echo_on_set($input["TH_URG"],null,"&TH_URG=".$input["TH_URG"]);
		$ret .= echo_on_set($input["TH_ECE"],null,"&TH_ECE=".$input["TH_ECE"]);
		$ret .= echo_on_set($input["TH_CWR"],null,"&TH_CWR=".$input["TH_CWR"]);
	}
	else if ($input["protocol"] == "2") {
		$ret .= echo_on_set($input["icmp_type"],null,"&icmp_type=".$input["icmp_type"]);
		$ret .= echo_on_set($input["icmp_code"],null,"&icmp_code=".$input["icmp_code"]);
	}
	$ret .= echo_on_set($input["banner"],null,"&banner=".$input["banner"]);
	$ret .= echo_on_set($input["os"],null,"&os=".$input["os"]);
	return $ret;
}


function data_correlation_form($dat)
{
	if (!(isset($dat["protocol"]))) $dat["protocol"] = 0;
	print "<form action=\"/scan_data/data_select.php\" method=\"POST\">\n";
	print "Enter search terms (check boxes indicate inverse logic):\n";
	print "<dd>\n!<input type=\"checkbox\" name=\"not_host_addr\" value=\"TRUE\" ".is_checked($dat["not_host_addr"], "TRUE").">\n"; 
	print "<input type=\"text\" name=\"host_addr\" size=\"20\" maxlength=\"20\" value=\"".$dat["host_addr"]."\"> Host Address: (use CIDR, /32 implied)\n";
	print "<dd>\n!<input type=\"checkbox\" name=\"not_trace_addr\" value=\"TRUE\" ".is_checked($dat["not_trace_addr"], "TRUE").">\n";
	print "<input type=\"text\" name=\"trace_addr\" size=\"20\" maxlength=\"20\" value=\"".$dat["trace_addr"]."\"> Trace Address:  (use CIDR, /32 implied)\n";
	print "<dd>\n!<input type=\"checkbox\" name=\"not_sport\" value=\"TRUE\" ".is_checked($dat["not_sport"], "TRUE").">\n";
	print "<input type=\"text\" name=\"sport\" size=\"20\" maxlength=\"20\" value=\"".$dat["sport"]."\"> Source Port\n";
	print "<dd>\n!<input type=\"checkbox\" name=\"not_dport\" value=\"TRUE\" ".is_checked($dat["not_dport"], "TRUE").">\n";
 	print "<input type=\"text\" name=\"dport\" size=\"20\" maxlength=\"20\" value=\"".$dat["dport"]."\"> Destination Port\n";
	print "</dd><br/>\n";
	print "<dd>\n&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type=\"text\" name=\"banner\" size=\"20\" maxlength=\"20\" value=\"".urldecode($dat["banner"])."\"> Banner (ext-RegEx)\n";
	print "<dd>\n&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type=\"text\" name=\"os\" size=\"20\" maxlength=\"20\" value=\"".urldecode($dat["os"])."\"> Host Operating System (ext-RegEx)\n";
	print "</dd>\n";
	print "<br/>\nSelect Protocol To Look For.\n";
	print "<dd>\n<input type=\"radio\" name=\"protocol\" value=6 ".is_checked($dat["protocol"], 6)."> TCP\n";
	print "<input type=\"checkbox\" name=\"TH_FIN\" value=\"TRUE\" ".is_checked($dat["TH_FIN"], "TRUE")."> FIN\n";
	print "<input type=\"checkbox\" name=\"TH_SYN\" value=\"TRUE\" ".is_checked($dat["TH_SYN"], "TRUE")."> SYN\n";
	print "<input type=\"checkbox\" name=\"TH_RST\" value=\"TRUE\" ".is_checked($dat["TH_RST"], "TRUE")."> RST\n";
	print "<input type=\"checkbox\" name=\"TH_PSH\" value=\"TRUE\" ".is_checked($dat["TH_PSH"], "TRUE")."> PSH\n";
	print "<input type=\"checkbox\" name=\"TH_ACK\" value=\"TRUE\" ".is_checked($dat["TH_ACK"], "TRUE")."> ACK\n";
	print "<input type=\"checkbox\" name=\"TH_URG\" value=\"TRUE\" ".is_checked($dat["TH_URG"], "TRUE")."> URG\n";
	print "<input type=\"checkbox\" name=\"TH_ECE\" value=\"TRUE\" ".is_checked($dat["TH_ECE"], "TRUE")."> ECE\n";
	print "<input type=\"checkbox\" name=\"TH_CWR\" value=\"TRUE\" ".is_checked($dat["TH_CWR"], "TRUE")."> CWR\n";
	print "<dd>\n<input type=\"radio\" name=\"protocol\" value=17 ".is_checked($dat["protocol"], 17)."> UDP\n";
	print "<dd><input type=\"radio\" name=\"protocol\" value=2 ".is_checked($dat["protocol"], 2)."> ICMP\n";
	print "<input type=\"text\" name=\"icmp_type\" size=\"3\" maxlength=\"3\" value=\"".$dat["icmp_type"]."\"> Type\n";
	print "<input type=\"text\" name=\"icmp_code\" size=\"3\" maxlength=\"3\" value=\"".$dat["icmp_code"]."\"> Code\n";
	print "<dd><input type=\"radio\" name=\"protocol\" value=0 ".is_checked($dat["protocol"], 0)."> ANY\n";
	print "<br/>\n<br/>\n<br/>\n<input type=submit value=\"submit\">\n</form>\n";
}


	if ($_SERVER["REQUEST_METHOD"] == "POST" || isset($_GET["mask"])) {
		if ($_SERVER["REQUEST_METHOD"] == "POST") $info = $_POST;
		else if ($_SERVER["REQUEST_METHOD"] == "GET" && isset($_GET["mask"])) $info = $_GET;


		$resp = new responseclass;
		$resp = $resp->db2response($info);

		print "<pre>";
		$format = " <a href=\"".$_SERVER[$PHP_SELF].get_opts_mask($info,1<<1)."\" target=\"_self\">%-15s</a> | <a href=\"".$_SERVER[$PHP_SELF].get_opts_mask($info,1<<2)."\" target=\"_self\">%-15s</a> | <a href=\"".$_SERVER[$PHP_SELF].get_opts_mask($info,1<<3)."\" target=\"_self\">%5s</a> | <a href=\"".$_SERVER[$PHP_SELF].get_opts_mask($info,1<<4)."\" target=\"_self\">%5s</a> | <a href=\"".$_SERVER[$PHP_SELF].get_opts_mask($info,1<<5)."\" target=\"_self\">%8s</a> | <a href=\"".$_SERVER[$PHP_SELF].get_opts_mask($info,1<<6)."\" target=\"_self\">%8s</a> | <a href=\"".$_SERVER[$PHP_SELF].get_opts_mask($info,1<<7)."\" target=\"_self\">%8s</a> | <a href=\"".$_SERVER[$PHP_SELF].get_opts_mask($info,1<<8)."\" target=\"_self\">%3s</a> | <a href=\"".$_SERVER[$PHP_SELF].get_opts_mask($info,1<<9)."\" target=\"_self\">%-20s</a> | <a href=\"".$_SERVER[$PHP_SELF].get_opts_mask($info,1<<10)."\" target=\"_self\">%-20s</a>\n";
		printf($format,"host address","trace address","dport","sport","protocol","type  ","subtype","ttl","operating system","   banner");
		print "-----------------+-----------------+-------+-------+----------+----------+----------+-----+----------------------+------------------\n";

		for ($j=0; $j<count($resp); $j++) {
			print "<a href=\"".$_SERVER[$PHP_SELF]."?mode=1&host_addr=".($resp[$j]->host_addr)."\" target=\"_self\">";
			$resp[$j]->print_response_info();
			print "</a>";
		}
		print "</pre><br/>\n";
		data_correlation_form($info);
	} else if ($_SERVER["REQUEST_METHOD"] == "GET" && !isset($_GET["mode"])) {
		data_correlation_form(NULL);
	} else if ($_SERVER["REQUEST_METHOD"] == "GET" && $_GET["mode"] == 1) {		// show details
		$info = $_GET;
		$resp = new responseclass;
                $resp = $resp->db2response($info);
		print "<h2>IP Address: ".long2ip($info["host_addr"])."</h2>";
		print "<pre>";
                for ($j=0; $j<count($resp); $j++) {
                        $resp[$j]->print_response_info_detail();
                }
		print "</pre>";
	}

?>
