<?
/**************************************************************************************** 
 *											*
 *     Copyright (C) <2004>  <Josh J. Zelonis> <josh@dyadsecurity.com>			*
 *											*
 *											*
 *     This library is free software; you can redistribute it and/or			*
 *     modify it under the terms of the GNU Lesser General Public			*
 *     License as published by the Free Software Foundation; either			*
 *     version 2.1 of the License, or (at your option) any later version.		*
 * 											*
 *     This library is distributed in the hope that it will be useful,			*
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU		*
 *     Lesser General Public License for more details.					*
 * 											*
 *     You should have received a copy of the GNU Lesser General Public			*
 *     License along with this library; if not, write to the Free Software		*
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	*
 *											*
 ****************************************************************************************/

require("../config.php");
require($UNICORN["filesystem_unicorn-lib"]."scheduleclass.php");

function print_form()
{
	print <<<EOF
<form action="/scan_data/scheduler.php" method="POST">
Enter scan options (blank options will default to 'unicorn.config' values):
	<dd>
		<input type="text" name="target" size="20" maxlength="199">
		Target Range (use <a href="/help/help.php?_help=CIDR" target="left">CIDR</a>, /32 implied)
	<dd>
		<input type="text" name="portstr" size="20" maxlength="199">
		Ports to scan (comma separated list, or 'a' for all and 'q' for quick default)
	<dd>
		<input type="text" name="pps" size="20" maxlength="9">
		<a href="/help/help.php?_help=scan_rate" target="left">Scan rate</a> (packets per second)
	</dd>

	<br/>Select protocol: 
	<dd>
		<input type="radio" name="scanmode" value=6 checked> 
		<a href="/help/help.php?_help=tcp_opts" target="left">TCP</a>
		<input type="checkbox" name="TH_FIN" value="TRUE"> FIN 
		<input type="checkbox" name="TH_SYN" value="TRUE" checked> SYN 
		<input type="checkbox" name="TH_RST" value="TRUE"> RST 
		<input type="checkbox" name="TH_PSH" value="TRUE"> PSH 
		<input type="checkbox" name="TH_ACK" value="TRUE"> ACK 
		<input type="checkbox" name="TH_URG" value="TRUE"> URG 
		<input type="checkbox" name="TH_ECE" value="TRUE"> ECE 
		<input type="checkbox" name="TH_CWR" value="TRUE"> CWR
	<dd>
		<input type="radio" name="scanmode" value=17>
		<a href="/help/help.php?_help=udp_opts" target="left">UDP</a>
	<dd>
		<input type="radio" name="scanmode" value="0"> Bannergrab
	</dd>		
 

	<br/>Select sender options:
	<dd>
		<input type="radio" name="packet_src" value=0 checked> Send packets from IP Address of primary NIC. 
	<dd>
		<input type="radio" name="packet_src" value=1> Send packets from this IP address: 
		<input type="text" name="srcaddr" size="20" maxlength="20">
	<dd>
		<input type="checkbox" name="fantaip" value="TRUE"> 
		<a href="/help/help.php?_help=fantaip" target="left">FantaIP</a> for this IP<br>
	<dd>
		<input type="radio" name="packet_src" value=2> Send packets from random addresses
	<br>
	<dd>
		<input type="text" name="srcport" size="5" maxlength="5" value="-1"> &nbsp; Send packets from this source port (-1 means random)
	</dd>


	<br/>Select an <a href="/help/help.php?_help=stack_emu" target="left">ip stack</a> to emulate:
	<dd>
		<input type="radio" name="fingerprint" value=0 checked> Cisco
	<dd>
		<input type="radio" name="fingerprint" value=1> OpenBSD
	<dd>
		<input type="radio" name="fingerprint" value=2> Windows XP
	<dd>
		<input type="radio" name="fingerprint" value=3> Random
	</dd>


	<br/>Additional options:
	<dd>
		<input type="checkbox" name="os_detect" value="TRUE" checked> Perform OS Detection
	<dd>
		<input type="checkbox" name="no_shuffle" value="TRUE"> Do not shuffle destination ports
	<dd>
		<input type="checkbox" name="crc_transport" value="TRUE"> Broken Transport Layer CRC
	<dd>
		<input type="checkbox" name="crc_network" value="TRUE"> Broken Network Layer CRC
	<dd>
		<input type="checkbox" name="no_defpayload" value="TRUE"> No default payload (Don't try to probe unknown protocols)

	<dd>
		<input type="text" name="ipttl" size="6" maxlength="3"> IP time to live
	<dd>
		<input type="text" name="iptos" size="6" maxlength="3"> IP type of service
	<dd>
		<input type="text" name="repeats" size="6" maxlength="6"> 
		<a href="/help/help.php?_help=repeats" target="left">Repeat</a> packet scan N times
	<br/>
	<br/>Use extra <a href="/help/help.php?_help=pcap_filter" target="left">pcap filter</a> on receiver:
	<dd>
		<input type="text" name="pcapfilter" size="50" maxlength="200">
	<br/>
	<br/>
		<input type=submit value="submit">
</form>

EOF;
}


	if ($_SERVER["REQUEST_METHOD"] == "GET") {
		print_form();
	} else if ($_SERVER["REQUEST_METHOD"] == "POST") {
		$scan = new scheduleclass;
		$scan->array2schedule($_POST);
		$scan->schedule2db();
		print "Your scan has been scheduled.";
		require("scan_queue.php");
	}


?>
