<?
/**************************************************************************************** 
 *											*
 *     Copyright (C) <2004>  <Josh J. Zelonis> <josh@dyadsecurity.com>			*
 *											*
 *											*
 *     This library is free software; you can redistribute it and/or			*
 *     modify it under the terms of the GNU Lesser General Public			*
 *     License as published by the Free Software Foundation; either			*
 *     version 2.1 of the License, or (at your option) any later version.		*
 * 											*
 *     This library is distributed in the hope that it will be useful,			*
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU		*
 *     Lesser General Public License for more details.					*
 * 											*
 *     You should have received a copy of the GNU Lesser General Public			*
 *     License along with this library; if not, write to the Free Software		*
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	*
 *											*
 ****************************************************************************************/


if (!(defined("unicorn_defines"))) {
        define("unicorn_defines", 1);



function delete_invalid_scan_data($scan_id)
{
	global $db;

	$query="delete from scan_bucket where scan_id = ".$scan_id;
	$db -> aquerydb($query);
	$query="delete from scan where scan_id = ".$scan_id;
	$db -> aquerydb($query);
}

function tcpflags_itoa($f_int)
{
	$TCPFLAGS = array(0x01=>"FIN", 0x02=>"SYN", 0x04=>"RST", 0x08=>"PSH", 0x10=>"ACK", 0x20=>"URG", 0x40=>"ECE", 0x80=>"CWR"); /* FSRPAUEC */
	$f_str = null;
	for ($i=0x01; $i<=0x80; $i=$i<<1) {
		if (($i & $f_int) == $i) {
			if (($f_int % $i) > 0) $f_str .= "|";
			$f_str .= $TCPFLAGS[$i];
		}
	}
	return $f_str;
}

function tcpflags_itoashort($f_int)
{
	dprint("Entering tcpflags_itoashort...");
	$TCPFLAGS = array(0x01=>"F", 0x02=>"S", 0x04=>"R", 0x08=>"P", 0x10=>"A", 0x20=>"U", 0x40=>"E", 0x80=>"C"); /* FSRPAUEC */
	$f_str = null;
	for ($i=0x01; $i<=0x80; $i=$i<<1) {
		if (($i & $f_int) == $i) {
			$f_str .= $TCPFLAGS[$i];
		}
	}
	return $f_str;
}


function get_address_range($dat)
{
	dprint("Entering get_address_range...");
	$netmask = array
	(
		0x00000000, 0x80000000, 0xc0000000, 0xe0000000, 0xf0000000, 0xf8000000, 0xfc000000,
		0xfe000000, 0xff000000, 0xff800000, 0xffc00000, 0xffe00000, 0xfff00000, 0xfff80000,
		0xfffc0000, 0xfffe0000, 0xffff0000, 0xffff8000, 0xffffc000, 0xffffe000, 0xfffff000,
		0xfffff800, 0xfffffc00, 0xfffffe00, 0xffffff00, 0xffffff80, 0xffffffc0, 0xffffffe0,
		0xfffffff0, 0xfffffff8, 0xfffffffc, 0xfffffffe, 0xffffffff
	);

	if (strlen(strstr($dat,"/")) > 0) {
		$target = explode("/",$dat);
		$ip=trim($target[0]);
		$mask=(int)trim($target[1]);
		$addr["min"]=sprintf("%u", (ip2long($ip) & $netmask[$mask]));
		$addr["max"]=sprintf("%u", (ip2long($ip) | (0xFFFFFFFF ^ $netmask[$mask])));
	} else {
		$addr["min"]=sprintf("%u", (ip2long($dat)));
		$addr["max"]=sprintf("%u", (ip2long($dat)));
	}
	return $addr;
}

function is_checked($dat, $val)
{
        if ($dat == $val) return "checked";
}

function echo_on_set($dat, $ret1, $ret2="", $val="")
{
        if ($dat == $val) return $ret1;
        return $ret2;
}

function validate_input($input, $valid, $maxlen=-1)
{
	if (($maxlen != -1) && (strlen($input) > $maxlen)) trigger_error("validate_input: Invalid string ".strlen($input)." length passed as input: ".$input);
	for ($i=0; $i<strlen($input); $i++) {
		if (!(stristr($valid, $input[$i]))) trigger_error("validate_input: Invalid character '".$input[$i]."' detected in input: ".$input);
	}
}



}

?>
