<?php
/**************************************************************************************** 
 *											*
 *     Copyright (C) <2004>  <Josh J. Zelonis> <josh@dyadsecurity.com>			*
 *											*
 *											*
 *     This library is free software; you can redistribute it and/or			*
 *     modify it under the terms of the GNU Lesser General Public			*
 *     License as published by the Free Software Foundation; either			*
 *     version 2.1 of the License, or (at your option) any later version.		*
 * 											*
 *     This library is distributed in the hope that it will be useful,			*
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU		*
 *     Lesser General Public License for more details.					*
 * 											*
 *     You should have received a copy of the GNU Lesser General Public			*
 *     License along with this library; if not, write to the Free Software		*
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	*
 *											*
 ****************************************************************************************/


if (!(defined("dbclass_include"))) {
	define("dbclass_include",1);

	global $UNICORN;
	require($UNICORN["filesystem_unicorn-lib"]."debug.php");
	require($UNICORN["filesystem_unicorn-lib"]."db_config.php");

	class dbclass {
		/* Public?, too bad.... */
		var $username;
		var $password;
		var $server;
		var $port;
		var $db;
		var $conn_str;

		var $query;

		/* Private?, too bad..... */
		var $resultarr;
		var $row_num;
		var $numrows;
		var $link;
		var $resultptr;

		/* Constructor function..... */
		function dbclass() {
			global $UNICORN;

			$this->resultarr=array();
			$this->row_num=0;
			$this->numrows=0;
			$this->link="";
			$this->resultptr="";

			$this->query="";

			$this->username=$UNICORN["database_username"];
			$this->password=$UNICORN["database_password"];
			$this->server=$UNICORN["database_host"];
			$this->port=$UNICORN["database_port"];
			$this->db=$UNICORN["database_type"];
			$this->conn_str="";
		}


		function select_db($db = "") {
			if (strlen($db)) $this->db=$db;
			$this->conn_str="user=".$this->username." password=".$this->password." dbname=".$this->db." host=".$this->server;
			if (!($this->link=pg_connect($this->conn_str))) {
				trigger_error("Can't Connect to DataBase, PostGreSQL error: '".pg_errormessage()."'",E_USER_ERROR);
			}
		}

		function aquerydb($query) {
			/* Checks for a zero length query, queries and does error reporting */
			if (!(strlen($query))) {
				trigger_error("Empty query passed to aquerydb",E_USER_WARN);
			}
			$this->query=$query;


			$this->row_num=0;
			if (!(@$this->resultptr=pg_exec($this->link,$this->query))) {
				trigger_error("pgsql_query() in dbclass (pgsql): '".pg_errormessage()."'",E_USER_ERROR);
			}
			if (stristr($this->query,"select")) {
				@$this->numrows=pg_numrows($this->resultptr);
				if ($this->numrows == 1) {
					$this->resultarr=pg_fetch_array($this->resultptr,0);
				}
			}
		}

		function agetassarr($query) {
			/* Checks for a zero length query, queries and does error reporting */
			if (!(strlen($query))) {
				trigger_error("Empty query passed to agetassarr",E_USER_WARN);
				return -1;
			}
			$this->query=$query;

			$this->row_num=0;
			if (!($this->resultptr=pg_exec($this->link,$this->query))) {
				trigger_error("pgsql_query() in dbclass (pgsql): '".pg_errormessage()."'",E_USER_ERROR);
			}
			if (stristr($this->query,"select")) {
				@$this->numrows=pg_numrows($this->resultptr);
				if ($this->numrows == 1) {
					$this->resultarr=pg_fetch_array($this->resultptr,0,PGSQL_ASSOC);
				}
			}
		}

		function data_step() {
			@$this->resultarr=pg_fetch_array($this->resultptr,$this->row_num++);
		}

		function _escape_string($val) {
			return pg_escape_string($val);
		}

		function destructor() {
			if ($this->link) {
				pg_close($this->link);
			}
		}
	}
}

?>
