<?PHP
/**************************************************************************************** 
 *											*
 *     Copyright (C) <2004>  <Josh J. Zelonis> <josh@dyadsecurity.com>			*
 *											*
 *											*
 *     This library is free software; you can redistribute it and/or			*
 *     modify it under the terms of the GNU Lesser General Public			*
 *     License as published by the Free Software Foundation; either			*
 *     version 2.1 of the License, or (at your option) any later version.		*
 * 											*
 *     This library is distributed in the hope that it will be useful,			*
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU		*
 *     Lesser General Public License for more details.					*
 * 											*
 *     You should have received a copy of the GNU Lesser General Public			*
 *     License along with this library; if not, write to the Free Software		*
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	*
 *											*
 ****************************************************************************************/


if (!(defined("responseclass_include"))) {
	define("responseclass_include",1);

	global $UNICORN;

class responseclass {
        var $scan_id	= null;
        var $protocol	= null;
        var $host_addr	= null;
        var $trace_addr	= null;
        var $dport	= null;
        var $sport	= null;
        var $type	= null;
        var $subtype	= null;
        var $ttl	= null;
        var $os		= null;
        var $banner	= null;
        var $u_tstamp	= null;
        var $u_utstamp	= null;


	/********************************************************
	 * Methods for converting object to and from data types *
	 ********************************************************/

	function db2response($input = null)
	{
		dprint("Entering db2response...");

		global $db;
		$condition = null;
		$ordering = array(0x000=>" asc",0x001=>" desc",0x002=>"order by host_addr",0x004=>"order by trace_addr",0x008=>"order by dport",0x010=>"order by sport",0x020=>"order by protocol",0x040=>"order by type",0x080=>"order by subtype",0x100=>"order by ttl",0x200=>"order by os",0x400=>"order by banner");

		if ($input["scan_id"] != null) $condition .= echo_on_set($condition, " ", " and ")."scan_id = ".$input["scan_id"];
		if ($input["host_addr"] != "") {
			$host_addr = get_address_range($input["host_addr"]);
			$condition .= echo_on_set($condition, " ", " and ").echo_on_set($input["not_host_addr"], "host_addr <= ".$host_addr["min"]." and host_addr >= ".$host_addr["max"], "host_addr >= ".$host_addr["min"]." and host_addr <= ".$host_addr["max"], "TRUE");
		}
		if ($input["trace_addr"] != "") {
			$trace_addr = get_address_range($input["trace_addr"]);
			$condition .= echo_on_set($condition, " ", " and ").echo_on_set($input["not_trace_addr"], "trace_addr <= ".$trace_addr["min"]." and trace_addr >= ".$trace_addr["max"], "trace_addr >= ".$trace_addr["min"]." and trace_addr <= ".$trace_addr["max"], "TRUE");
		}
		if ($input["sport"] != "") $condition .= echo_on_set($condition, " ", " and ").echo_on_set($input["not_sport"], "sport != ".$input["sport"], "sport = ".$input["sport"], "TRUE");
		if ($input["dport"] != "") $condition .= echo_on_set($condition, " ", " and ").echo_on_set($input["not_dport"], "dport != ".$input["dport"], "dport = ".$input["dport"], "TRUE");
		if ($input["protocol"] == "17") $condition .= echo_on_set($condition, " ", " and ")."protocol = ".$input["protocol"];
		if ($input["protocol"] == "6") $condition .= echo_on_set($condition, " ", " and ")."type = ".(0x80*isset($input["TH_CWR"])+0x40*isset($input["TH_ECE"])+0x20*isset($input["TH_URG"])+0x10*isset($input["TH_ACK"])+0x08*isset($input["TH_PSH"])+0x04*isset($input["TH_RST"])+0x02*isset($input["TH_SYN"])+0x01*isset($input["TH_FIN"])); 
		if ($input["protocol"] == "2" && $input["icmp_type"] != "") $condition .= echo_on_set($condition, " ", " and ")."type = ".$input["icmp_type"];
		if ($input["protocol"] == "2" && $input["icmp_code"] != "") $condition .= echo_on_set($condition, " ", " and ")."subtype = ".$input["icmp_code"];
		if ($input["banner"] != "") $condition .= echo_on_set($condition, " ", " and ")."banner ~* '".$input["banner"]."'";
		if ($input["os"] != "") $condition .= echo_on_set($condition, " ", " and ")."os ~* '".$input["os"]."'";
		$query = "select * from response_info".echo_on_set($condition, null, " where ".$condition)." ".echo_on_set($input["mask"], null, " ".$ordering[($input["mask"]&0xFFE)].$ordering[($input["mask"]&0x001)]);
	
		dprint($query);

		$db->agetassarr($query);
		$arr = array();
		for ($i=0; $i<$db->numrows; $i++) {
			if ($db->numrows >0) $db->data_step();
			$arr[$i]=new responseclass;
			$arr[$i]->array2response($db->resultarr);
		}
		return $arr;
	}

	function array2response($arr)
	{
		dprint("Entering array2response...");
		$this->scan_id		= $arr["scan_id"];
		$this->protocol		= $arr["protocol"];
		$this->host_addr	= $arr["host_addr"];
		$this->trace_addr	= $arr["trace_addr"];
		$this->dport		= $arr["dport"];
		$this->sport		= $arr["sport"];
		$this->type		= $arr["type"];
		$this->subtype		= $arr["subtype"];
		$this->ttl		= $arr["ttl"];
		$this->os		= $arr["os"];
		$this->banner		= $arr["banner"];
		$this->u_tstamp		= $arr["u_tstamp"];
		$this->u_utstamp	= $arr["u_utstamp"];
	}

	function print_response_info()
	{
		dprint("Entering print_response_info...");
		$proto = array(2=>"icmp",6=>"tcp",17=>"udp");
		if ($this->protocol == 6) {
			$format = " %-15s | %-15s | %5d | %5d | %8s | %8s | %8d | %3d | %-20s | %-20s\n";
			printf($format,long2ip($this->host_addr),long2ip($this->trace_addr),$this->dport,$this->sport,$proto[($this->protocol)],tcpflags_itoashort($this->type),$this->subtype,$this->ttl,substr(($this->os),0,20),substr(($this->banner),0,20));
		}
		else {
			$format = " %-15s | %-15s | %5d | %5d | %8s | %8d | %8d | %3d | %-20s | %-20s\n";
			printf($format,long2ip($this->host_addr),long2ip($this->trace_addr),$this->dport,$this->sport,$proto[($this->protocol)],$this->type,$this->subtype,$this->ttl,substr(($this->os),0,20),substr(($this->banner),0,20));
		}
	}

	function print_response_info_detail()
	{
		dprint("Entering print_response_info_detail...");
		$proto = array(2=>"icmp",6=>"tcp",17=>"udp");

		print "Protocol: ".$proto[($this->protocol)]."\tPort: ".$this->sport."\n";
		print "Trace Address: ".long2ip($this->trace_addr)."\n";
		if ($this->protocol == 6) print "TCP Flags: ".tcpflags_itoa($this->type)."\n";
		else if ($this->protocol == 2) print "Type: ".$this->type."\tCode: ".$this->subtype."\n";
		else print "Type: ".$this->type."\tSubtype: ".$this->subtype."\n";
		print "TTL: ".$this->ttl."\n";
		print "OS Fingerprint: ".$this->os."\n";
		print "Service Banner: ".$this->banner."\n\n";
	}

} // end responseclass

	function delete_selected_response()
	{
		global $db;
		dprint("Entering delete_selected_response...");
		$condition == null;
		if ($input["scan_id"] != null) $condition .= echo_on_set($condition, " ", " and ")."scan_id = ".$input["scan_id"];
		if ($input["host_addr"] != "") {
			$host_addr = get_address_range($input["host_addr"]);
			$condition .= echo_on_set($condition, " ", " and ").echo_on_set($input["not_host_addr"], "host_addr <= ".$host_addr["min"]." and host_addr >= ".$host_addr["max"], "host_addr >= ".$host_addr["min"]." and host_addr <= ".$host_addr["max"], "TRUE");
		}
		if ($input["trace_addr"] != "") {
			$trace_addr = get_address_range($input["trace_addr"]);
			$condition .= echo_on_set($condition, " ", " and ").echo_on_set($input["not_trace_addr"], "trace_addr <= ".$trace_addr["min"]." and trace_addr >= ".$trace_addr["max"], "trace_addr >= ".$trace_addr["min"]." and trace_addr <= ".$trace_addr["max"], "TRUE");
		}
		if ($input["sport"] != "") $condition .= echo_on_set($condition, " ", " and ").echo_on_set($input["not_sport"], "sport != ".$input["sport"], "sport = ".$input["sport"], "TRUE");
		if ($input["dport"] != "") $condition .= echo_on_set($condition, " ", " and ").echo_on_set($input["not_dport"], "dport != ".$input["dport"], "dport = ".$input["dport"], "TRUE");
		if ($input["protocol"] == "17") $condition .= echo_on_set($condition, " ", " and ")."protocol = ".$input["protocol"];
		if ($input["protocol"] == "6") $condition .= echo_on_set($condition, " ", " and ")."type = ".(0x80*isset($input["TH_CWR"])+0x40*isset($input["TH_ECE"])+0x20*isset($input["TH_URG"])+0x10*isset($input["TH_ACK"])+0x08*isset($input["TH_PSH"])+0x04*isset($input["TH_RST"])+0x02*isset($input["TH_SYN"])+0x01*isset($input["TH_FIN"])); 
		if ($input["protocol"] == "2" && $input["icmp_type"] != "") $condition .= echo_on_set($condition, " ", " and ")."type = ".$input["icmp_type"];
		if ($input["protocol"] == "2" && $input["icmp_code"] != "") $condition .= echo_on_set($condition, " ", " and ")."subtype = ".$input["icmp_code"];
		if ($input["banner"] != "") $condition .= echo_on_set($condition, " ", " and ")."scan_bucket_id in (select scan_bucket_id from banner where banner ~* '".$input["banner"]."')";
		if ($input["os"] != "") $condition .= echo_on_set($condition, " ", " and ")."scan_bucket_id in (select scan_bucket_id from os_fingerprint where os ~* '".$input["os"]."')";

		$query1 = "delete from scan_bucket where ".$cond;
		$query2 = "delete from os_fingerprint where scan_bucket_id in (select scan_bucket_id from scan_bucket where ".$cond.")";
		$query3 = "delete from banner where scan_bucket_id in (select scan_bucket_id from scan_bucket where ".$cond.")";
print "$query3";
		$db->aquerydb($query3);
print "$query2";
		$db->aquerydb($query2);
print "$query1";
		$db->aquerydb($query1);
	}

} // end double include protection

?>
