<?PHP
/**************************************************************************************** 
 *											*
 *     Copyright (C) <2004>  <Josh J. Zelonis> <josh@dyadsecurity.com>			*
 *											*
 *											*
 *     This library is free software; you can redistribute it and/or			*
 *     modify it under the terms of the GNU Lesser General Public			*
 *     License as published by the Free Software Foundation; either			*
 *     version 2.1 of the License, or (at your option) any later version.		*
 * 											*
 *     This library is distributed in the hope that it will be useful,			*
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU		*
 *     Lesser General Public License for more details.					*
 * 											*
 *     You should have received a copy of the GNU Lesser General Public			*
 *     License along with this library; if not, write to the Free Software		*
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	*
 *											*
 ****************************************************************************************/


if (!(defined("scanclass_include"))) {
	define("scanclass_include",1);

	global $UNICORN;

class scanclass {
	var $scan_id	 	= null;
	var $s_time		= null;
	var $e_time		= null;
	var $addrmax 		= null;
	var $addrmin 		= null;
	var $portstr 		= null;
	var $scanmode 		= null;
	var $pps 		= null;
	var $srcaddr 		= null;
	var $srcport	 	= null;
	var $fingerprint 	= null;
	var $tcpflags 		= null;
	var $active_plgroups 	= null;
	var $dronestr		= null;
	var $ipttl 		= null;
	var $iptos 		= null;
	var $ipoffset 		= null;
	var $repeats 		= null;
	var $pcapfilter 	= null;


	/********************************************************
	 * Methods for converting object to and from data types *
	 ********************************************************/

	function db2scan($val = null)
	{
		dprint("Entering db2scan...");
		global $db;
		$query = "select * from scan".echo_on_set($val,null," where scan_id = ".$val);
		$db->agetassarr($query);
		$arr = array();
		for ($i=0; $i<$db->numrows; $i++) {
			if ($db->numrows >0) $db->data_step();
			$arr[$i]=new scanclass;
			$arr[$i]->array2scan($db->resultarr);
		}
		return $arr;
	}

	function array2scan($arr)
	{
		dprint("Entering array2scan...");
		$this->scan_id		= $arr["scan_id"];
		$this->s_time		= $arr["s_time"];
		$this->e_time		= $arr["e_time"];
		$this->addrmax		= $arr["addrmax"];
		$this->addrmin		= $arr["addrmin"];
		$this->portstr		= $arr["portstr"];
		$this->scanmode		= $arr["scanmode"];
		$this->pps		= $arr["pps"];
		$this->srcaddr		= $arr["srcaddr"];
		$this->srcport		= $arr["srcport"];
		$this->fingerprint	= $arr["fingerprint"];
		$this->tcpflags		= $arr["tcpflags"];
		$this->active_plgroups	= $arr["active_plgroups"];
		$this->dronestr		= $arr["dronestr"];
		$this->ipttl		= $arr["ipttl"];
		$this->iptos		= $arr["iptos"];
		$this->ipoffset		= $arr["ipoffset"];
		$this->repeats		= $arr["repeats"];
		$this->pcapfilter	= $arr["pcapfilter"];
	}

	function print_scan_info()
	{
		dprint("Entering print_scan_info...");

		$TIME_FORMAT="%d/%m/%Y %r";
		$secs=((int)$this->e_time - (int)$this->s_time);
		$run_time="";
		if ($secs < 0) {
			$run_time="not completed";
		}
		else if ($secs < 60) {
			$run_time=$secs." Sec";
		}
		else if ($secs < (60 * 60)) {
			$minutes=(int)($secs / 60);
			$run_time=$minutes." Min ".($secs % 60)." Sec";
		}
		else if ($secs < (60 * 60 * 12)) {
			$hours=(int)($secs / (60 * 12));
			$minutes=(int)(($secs % (60 * 12)) / (60));
			$run_time=$hours." Hours ".$minutes." Min ".($secs % 60)." Sec";
		}
		else { 
			$run_time="A REALLY LONG TIME";
		}
		if ($this->scanmode == 1) $scanmode = "TCP ".tcpflags_itoa($this->tcpflags)." SCAN";
		else if ($this->scanmode == 2) $scanmode = "UDP SCAN";
		else if ($this->scanmode == 4) $scanmode = "SF SCAN";
		else if ($this->scanmode == 8) $scanmode = "IDLE SCAN";
		else if ($this->scanmode == 16) $scanmode = "ARP SCAN";
		else $scanmode = "Unknown";
		print "<pre>";
		print "\nScanID: ".$this->scan_id."\n";
		print "\tStart Time: ".strftime($TIME_FORMAT, (int)$this->s_time)."   Running Time: ".$run_time."\n";
		print "\tFrom Address: ".long2ip($this->srcaddr)." Ports: ".$this->portstr."\n";
		print "\tRange: ".long2ip($this->addrmin)." to ".long2ip($this->addrmax)."\n";
		print "\tRate: ".$this->pps." Type: ".$scanmode;
		print "</pre>";
	}

} // end scanclass

	function delete_scan($val)
	{
		dprint("Entering delete_scan...");
		global $db;
		$query = "delete from scan_bucket where scan_id = ".$val;
		$db->aquerydb($query);
		$query = "delete from scan where scan_id = ".$val;
		$db->aquerydb($query);
	}


} // end double include protection

?>
