<?PHP
/**************************************************************************************** 
 *											*
 *     Copyright (C) <2004>  <Josh J. Zelonis> <josh@dyadsecurity.com>			*
 *											*
 *											*
 *     This library is free software; you can redistribute it and/or			*
 *     modify it under the terms of the GNU Lesser General Public			*
 *     License as published by the Free Software Foundation; either			*
 *     version 2.1 of the License, or (at your option) any later version.		*
 * 											*
 *     This library is distributed in the hope that it will be useful,			*
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU		*
 *     Lesser General Public License for more details.					*
 * 											*
 *     You should have received a copy of the GNU Lesser General Public			*
 *     License along with this library; if not, write to the Free Software		*
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	*
 *											*
 ****************************************************************************************/


if (!(defined("scheduleclass_include"))) {
	define("scheduleclass_include",1);

	global $OSACE;
	
class scheduleclass {
	var $scan_queue_id 	= null;
	var $target 		= null;
	var $portstr 		= null;
	var $pps 		= null;

	var $scanmode 		= null;

	var $srcaddr 		= null;
	var $fantaip 		= null;
	var $srcport 		= null;
	var $fingerprint 	= null;

	var $brokencrc 		= null;
	var $ipttl 		= null;
	var $iptos 		= null;
	var $repeats 		= null;

	var $outputmods 	= null;
	var $extraargs	 	= null; 
	var $pcapfilter 	= null;


	/********************************************************
	 * Methods for converting object to and from data types *
	 ********************************************************/

	function schedule2db()
	{
		dprint("Entering schedule2db...");
		global $db;

$insert  = "insert into scan_queue(";					$values  = ") values(";
$insert .= echo_on_set($this->target, "", "target");			$values .= echo_on_set($this->target, "", "'".$this->target."'");
$insert .= echo_on_set($this->portstr, "", ",portstr");			$values .= echo_on_set($this->portstr, "", ",'".$this->portstr."'");
$insert .= echo_on_set($this->pps, "", ",pps");				$values .= echo_on_set($this->pps, "", ",".$this->pps);
$insert .= echo_on_set($this->scanmode, "", ",scanmode");		$values .= echo_on_set($this->scanmode, "", ",'".$this->scanmode."'");
$insert .= echo_on_set($this->srcaddr, "", ",srcaddr");			$values .= echo_on_set($this->srcaddr, "", ",'".$this->srcaddr."'");
$insert .= echo_on_set($this->fantaip, "", ",fantaip");			$values .= echo_on_set($this->fantaip, "", ",'".$this->fantaip."'");
$insert .= echo_on_set($this->srcport, "", ",srcport");		$values .= echo_on_set($this->srcport, "", ",".$this->srcport);
$insert .= echo_on_set($this->fingerprint, "", ",fingerprint");		$values .= echo_on_set($this->fingerprint, "", ",'".$this->fingerprint."'");
$insert .= echo_on_set($this->brokencrc, "", ",brokencrc");		$values .= echo_on_set($this->brokencrc, "", ",'".$this->brokencrc."'");
$insert .= echo_on_set($this->ipttl, "", ",ipttl");			$values .= echo_on_set($this->ipttl, "", ",".$this->ipttl);
$insert .= echo_on_set($this->iptos, "", ",iptos");			$values .= echo_on_set($this->iptos, "", ",".$this->iptos);
$insert .= echo_on_set($this->repeats, "", ",repeats");			$values .= echo_on_set($this->repeats, "", ",".$this->repeats);
$insert .= echo_on_set($this->outputmods, "", ",outputmods");		$values .= echo_on_set($this->outputmods, "", ",'".$this->outputmods."'");
$insert .= echo_on_set($this->extraargs, "", ",extraargs");	$values .= echo_on_set($this->extraargs, "", ",'".$this->extraargs."'");
$insert .= echo_on_set($this->pcapfilter, "", ",pcapfilter");		$values .= echo_on_set($this->pcapfilter, "", ",'".$this->pcapfilter."'").")";

		$query = $insert.$values;
		dprint($query);
		$db->aquerydb($query);
	}

	function db2schedule($val = null)
	{
		dprint("Entering db2schedule...");
		global $db;
		$query = "select * from scan_queue".echo_on_set($val,null," where scan_queue_id = ".$val);
		$db->agetassarr($query);
		$arr = array();
		for ($i=0; $i<$db->numrows; $i++) {
			if ($db->numrows >0) $db->data_step();
			$arr[$i]=new scheduleclass;
			$arr[$i]->scan_queue_id = $db->resultarr["scan_queue_id"];
			$arr[$i]->array2schedule($db->resultarr);
		}
		return $arr;
	}

	function array2schedule($arr)
	{
		dprint("Entering array2schedule...");
		$this->put_target($arr["target"]);
		$this->put_brokencrc($arr);
		$this->put_srcaddr($arr);
		$this->put_portstr($arr["portstr"]);
		$this->put_pps($arr["pps"]);
		$this->put_scanmode($arr);
		$this->put_fantaip($arr["fantaip"]);
		$this->put_srcport($arr["srcport"]);
		$this->put_fingerprint($arr["fingerprint"]);
		$this->put_ipttl($arr["ipttl"]);
		$this->put_iptos($arr["iptos"]);
		$this->put_repeats($arr["repeats"]);
		$this->put_outputmods($arr);
		$this->put_extraargs($arr);
		$this->put_pcapfilter($arr["pcapfilter"]);
	}

	function print_schedule_info()
	{
		dprint("Entering print_schedule_info...");
	        print "\nScanQueueID: ".$this->scan_queue_id."\n";
	        print "\tFrom Address: ".$this->srcaddr."\n";
	        print "\tTarget: ".$this->target."\n";
	        print "\tPorts: ".echo_on_set($this->portstr, "default", $this->portstr)."\n";
	        print "\tRate: ".echo_on_set($this->pps, "default", $this->pps)." Type: ".$this->scanmode."\n";
	}


	/********************************************************
	 * Methods for entering untrusted data into object 	*
	 ********************************************************/

	function put_target($val)
	{
		dprint("Entering put_target...");
		if (!(isset($val)) || $val == "") trigger_error("put_target: No target selected for scanning",E_USER_ERROR);
		validate_input($val, "0123456789./-abcdefghijklmnopqrstuvwxyz", 199);
		$this->target = $val;
	}

	function put_portstr($val)
	{
		dprint("Entering put_portstr...");
		if (isset($val)) {
			validate_input($val, "0123456789,-aq", 199);
			$this->portstr = $val;
		}
	}

	function put_pps($val)
	{
		dprint("Entering put_pps...");
		if (isset($val)) {
			validate_input($val, "0123456789", 9);
			$this->pps = $val;
		}
	}

	function put_scanmode($arr)
	{
		dprint("Entering put_scanmode...");
		if (isset($arr["scanmode"])) {
			validate_input($arr["scanmode"], "0123456789TUfsrpauec", 9);
			if ($arr["scanmode"]== 6) {
				$tmp = null;
				$tmp .= echo_on_set($arr["TH_FIN"], "F", "f","TRUE");
				$tmp .= echo_on_set($arr["TH_SYN"], "S", "s","TRUE");
				$tmp .= echo_on_set($arr["TH_RST"], "R", "r","TRUE");
				$tmp .= echo_on_set($arr["TH_PSH"], "P", "p","TRUE");
				$tmp .= echo_on_set($arr["TH_ACK"], "A", "a","TRUE");
				$tmp .= echo_on_set($arr["TH_URG"], "U", "u","TRUE");
				$tmp .= echo_on_set($arr["TH_ECE"], "E", "e","TRUE");
				$tmp .= echo_on_set($arr["TH_CWR"], "C", "c","TRUE");
				$this->scanmode = "T".$tmp;
			}
			else if ($arr["scanmode"][0] == "T") {
				validate_input($arr["scanmode"],"tfsrpauec",9);
				$this->scanmode = $arr["scanmode"];
			}
			else if (($arr["scanmode"] == 17) || ($arr["scanmode"] == "U")) $this->scanmode = "U";
			else if (($arr["scanmode"] == 0) || ($arr["scanmode"] == "sf")) $this->scanmode = "sf";
			else trigger_error("put_scanmode: something went wrong here, this is invalid input: ".$arr["scanmode"],E_USER_ERROR);
		}
	}

	function put_srcaddr($arr)
	{
		dprint("Entering put_srcaddr...");
		if (isset($arr["srcaddr"]) && !(isset($arr["packet_src"]))) {
			validate_input($arr["srcaddr"], "0123456789./-abcdefghijklmnopqrstuvwxyz", 199);
			$this->srcaddr = $arr["srcaddr"];
		}
		else if (isset($arr["srcaddr"]) && isset($arr["packet_src"])) {
			if ($arr["packet_src"] == 1) {
				validate_input($arr["srcaddr"], "0123456789./-abcdefghijklmnopqrstuvwxyz", 199);
				$this->srcaddr = $arr["srcaddr"];
			} else if ($arr["packet_src"] == 0) {
				$this->srcaddr = null;
			} else if ($arr["packet_src"] == 2) {
				$this->srcaddr = "r";
			} else {
				trigger_error("Something just went very wrong with the sender options, I can't believe what you are telling me",E_USER_ERROR);
			}
		}
	}

	function put_fantaip($val)
	{
		dprint("Entering put_fantaip...");
		if (($val == "TRUE") || ($val == 1)) $this->fantaip = 1;
		else $this->fantaip = 0;
	}

	function put_srcport($val)
	{
		dprint("Entering put_srcport...");
		if (isset($val)) {
			validate_input($val, "0123456789-", 5);
			if (!(($val >= -1) && ($val < 65536))) trigger_error("put_srcport: Invalid port specification",E_USER_ERROR);
			$this->srcport = $val;
		}
	}
	
	function put_fingerprint($val)
	{
		dprint("Entering put_fingerprint...");
		if (isset($val)) {
			validate_input($val, "0123456789", 1);
			$this->fingerprint = $val;
		}
	}

	function put_outputmods($arr)
	{
		dprint("Entering put_outputmods...");
		if (isset($arr["outputmods"])) {
			validate_input($arr["outputmods"], "abcdefghijklmnopqrstuvwxyz0123456789,", 199);
			$this->outputmods = $arr["outputmods"];
		}
		else {
			$this->outputmods = "database";
			if (isset($arr["os_detect"])) $this->outputmods .= ",p0f";
		}
	}

	function put_extraargs($arr)
	{
		dprint("Entering put_extraargs...");
		if (isset($arr["extraargs"])) {
			validate_input($arr["extraargs"], "SD", 2);
			$this->extraargs = $arr["extraargs"];
		} else {
			$this->extraargs = null;
			if (isset($arr["no_shuffle"])) $this->extraargs .= "S";
			if (isset($arr["no_defpayload"])) $this->extraargs .= "D";
		}
	}

	function put_brokencrc($arr)
	{
		dprint("Entering put_brokencrc...");
		if ((isset($arr["brokencrc"])) && (($arr["brokencrc"] == "TN") || ($arr["brokencrc"] == "T") || ($arr["brokencrc"] == "N"))) $this->brokencrc = $arr["brokencrc"];
		else {
			if (isset($arr["crc_transport"]) && isset($arr["crc_network"])) $this->brokencrc = "TN";
			else if (isset($arr["crc_transport"]) && !isset($arr["crc_network"])) $this->brokencrc = "T";
			else if (!isset($arr["crc_transport"]) && isset($arr["crc_network"])) $this->brokencrc = "N";
			else $this->brokencrc = null;
		}
	}

	function put_ipttl($val)
	{
		dprint("Entering put_ipttl...");
		if (isset($val)) {
			validate_input($val, "0123456789", 3);
			if (!(($val < 256) && ($val >= 0))) trigger_error("put_ipttl: Invalid IP Type of Service specification",E_USER_ERROR);
			$this->ipttl = $val;
		}
	}

	function put_iptos($val)
	{
		dprint("Entering put_iptos...");
		if (isset($val)) {
			validate_input($val, "0123456789", 3);
			if (!(($val < 256) && ($val >= 0))) trigger_error("put_iptos: Invalid IP Type of Service specification",E_USER_ERROR);
			$this->iptos = $val;
		}
	}

	function put_repeats($val)
	{
		dprint("Entering put_repeats...");
		if (isset($val)) {
			validate_input($val, "0123456789", 7);
			$this->repeats = $val;
		}
	}

	function put_pcapfilter($val)
	{
		dprint("Entering put_pcapfilter...");
		if (isset($val)) {
			validate_input($val, " abcdefghijklmnopqrstuvwxyz.0123456789-!&|()':", 199);
			$this->pcapfilter = $val;
		}
	}

} // end scheduleclass

	function delete_scheduled_scan($val)
	{
		dprint("Entering delete_scheduled_scan...");
		global $db;
		$query = "delete from scan_queue where scan_queue_id = ".$val;
		$db->aquerydb($query);
	}

} // end double inclusion protection
?>
